Index: main/cdr.c
===================================================================
--- main/cdr.c	(revision 429058)
+++ main/cdr.c	(working copy)
@@ -1355,12 +1355,20 @@
 
 	/*
 	 * Only record the context and extension if we aren't in a subroutine, or if
-	 * we are executing hangup logic.
+	 * we are executing hangup logic. If we don't have any record, however,
+	 * record it anyway.
 	 */
 	if (!ast_test_flag(&snapshot->flags, AST_FLAG_SUBROUTINE_EXEC)
 		|| ast_test_flag(&snapshot->softhangup_flags, AST_SOFTHANGUP_HANGUP_EXEC)) {
 		ast_string_field_set(cdr, context, snapshot->context);
 		ast_string_field_set(cdr, exten, snapshot->exten);
+	} else {
+		if (ast_strlen_zero(cdr->context)) {
+			ast_string_field_set(cdr, context, snapshot->context);
+		}
+		if (ast_strlen_zero(cdr->exten)) {
+			ast_string_field_set(cdr, exten, snapshot->exten);
+		}
 	}
 
 	cdr_object_swap_snapshot(&cdr->party_a, snapshot);
